## miniupnpd 1.7

=== Makefile ===
# $Id: Makefile,v 1.68 2012/05/23 08:46:14 nanard Exp $
# MiniUPnP project
# http://miniupnp.free.fr/ or http://miniupnp.tuxfamily.org/
# Author: Thomas Bernard
#
# Makefile for miniupnpd (MiniUPnP daemon)
#
# This Makefile should work for *BSD and SunOS/Solaris.
# On Mac OS X, use "bsdmake" to build.
# This Makefile is NOT compatible with GNU Make.
# Linux users, please use Makefile.linux :
#  make -f Makefile.linux
#
# options can be passed to genconfig.sh through CONFIG_OPTIONS :
# $ CONFIG_OPTIONS="--ipv6 --igd2" make
#

CFLAGS ?= -pipe -Os
#CFLAGS = -pipe -O -g -DDEBUG
CFLAGS += -ansi
CFLAGS += -Wall
CFLAGS += -W
CFLAGS += -Wstrict-prototypes
#CFLAGS += -Wdeclaration-after-statement
#CFLAGS += -Wno-missing-field-initializers
CFLAGS += -fno-common
CC ?= gcc
RM = rm -f
MV = mv
INSTALL = install
STRIP = strip

# OSNAME and FWNAME are used for building OS or FW dependent code.
OSNAME != uname -s
ARCH != uname -m
.ifndef FWNAME
.if exists(/usr/include/net/pfvar.h)
FWNAME = pf
.else
FWNAME = ipf
.endif
.endif

# better way to find if we are using ipf or pf
.if $(OSNAME) == "FreeBSD"
FWNAME != . /etc/rc.subr; . /etc/rc.conf; \
          if checkyesno ipfilter_enable; then \
          echo "ipf"; else echo "pf"; fi
.endif

.if $(OSNAME) == "NetBSD"
FWNAME != . /etc/rc.subr; . /etc/rc.conf; \
          if checkyesno ipfilter; then \
          echo "ipf"; else echo "pf"; fi
.endif

.if $(OSNAME) == "DragonFly"
FWNAME != . /etc/rc.subr; . /etc/rc.conf; \
          if chechyesno ipfilter; then \
          echo "ipf"; else echo "pf"; fi
.endif

.if $(OSNAME) == "Darwin"
FWNAME = ipfw
.endif

# Solaris specific CFLAGS
.if $(OSNAME) == "SunOS"
CFLAGS += -DSOLARIS2=`uname -r | cut -d. -f2`
.if $(ARCH) == "amd64"
CFLAGS += -m64 -mcmodel=kernel -mno-red-zone -ffreestanding
.elif $(ARCH) == "sparc64"
CFLAGS += -m64 -mcmodel=medlow
.endif
.endif

STDOBJS = miniupnpd.o upnphttp.o upnpdescgen.o upnpsoap.o \
          upnpredirect.o getifaddr.o daemonize.o upnpglobalvars.o \
          options.o upnppermissions.o minissdp.o natpmp.o \
          upnpevents.o upnputils.o getconnstatus.o \
          upnppinhole.o
BSDOBJS = bsd/getifstats.o bsd/ifacewatcher.o
SUNOSOBJS = solaris/getifstats.o bsd/ifacewatcher.o
MACOBJS = mac/getifstats.o bsd/ifacewatcher.o
PFOBJS = pf/obsdrdr.o pf/pfpinhole.o
IPFOBJS = ipf/ipfrdr.o
IPFWOBJS = ipfw/ipfwrdr.o
MISCOBJS = upnpreplyparse.o minixml.o

ALLOBJS = $(STDOBJS) $(MISCOBJS)
.if $(OSNAME) == "SunOS"
ALLOBJS += $(SUNOSOBJS)
TESTGETIFSTATSOBJS = testgetifstats.o solaris/getifstats.o
.elif $(OSNAME) == "Darwin"
ALLOBJS += $(MACOBJS)
TESTGETIFSTATSOBJS = testgetifstats.o mac/getifstats.o
.else
ALLOBJS += $(BSDOBJS)
TESTGETIFSTATSOBJS = testgetifstats.o bsd/getifstats.o
.endif

.if $(FWNAME) == "pf"
ALLOBJS += $(PFOBJS)
.elif $(FWNAME) == "ipfw"
ALLOBJS += $(IPFWOBJS)
.else
ALLOBJS += $(IPFOBJS)
.endif

TESTUPNPDESCGENOBJS = testupnpdescgen.o upnpdescgen.o
TESTUPNPPERMISSIONSOBJS = testupnppermissions.o upnppermissions.o
TESTGETIFADDROBJS = testgetifaddr.o getifaddr.o
MINIUPNPDCTLOBJS = miniupnpdctl.o

EXECUTABLES = miniupnpd testupnpdescgen testgetifstats \
              testupnppermissions miniupnpdctl \
              testgetifaddr
.if $(OSNAME) == "Darwin"
LIBS =
.else
LIBS = -lkvm
.endif
.if $(OSNAME) == "SunOS"
LIBS += -lsocket -lnsl -lkstat -lresolv
.endif

# set PREFIX variable to install in the wanted place

INSTALLBINDIR = $(PREFIX)/sbin
INSTALLETCDIR = $(PREFIX)/etc
# INSTALLMANDIR = $(PREFIX)/man
INSTALLMANDIR = /usr/share/man

all:	$(EXECUTABLES)

clean:
	$(RM) $(STDOBJS) $(BSDOBJS) $(SUNOSOBJS) $(MACOBJS) $(EXECUTABLES) \
	testupnpdescgen.o \
	$(MISCOBJS) config.h testgetifstats.o testupnppermissions.o \
	miniupnpdctl.o testgetifaddr.o \
	$(PFOBJS) $(IPFOBJS) $(IPFWOBJS)

install:	miniupnpd genuuid
	$(STRIP) miniupnpd
	$(INSTALL) -d $(DESTDIR)$(INSTALLBINDIR)
	$(INSTALL) -m 555 miniupnpd $(DESTDIR)$(INSTALLBINDIR)
	$(INSTALL) -d $(DESTDIR)$(INSTALLETCDIR)
	$(INSTALL) -b miniupnpd.conf $(DESTDIR)$(INSTALLETCDIR)
	# TODO : install man page correctly
#	$(INSTALL) -d $(INSTALLMANDIR)
#	$(INSTALL) miniupnpd.1 $(INSTALLMANDIR)/cat1/miniupnpd.0

# genuuid is using the uuid cli tool available under OpenBSD 4.0 in
# the uuid-1.5.0 package
# any other cli tool returning a uuid on stdout should work.
UUID != if which uuidgen 2>&1 > /dev/null; then \
        echo `uuidgen` ; \
        elif which uuid 2>&1 > /dev/null; then \
        echo `uuid` ; \
        else echo "00000000-0000-0000-0000-000000000000"; \
        fi

genuuid:
	$(MV) miniupnpd.conf miniupnpd.conf.before
	sed -e "s/^uuid=[-0-9a-fA-F]*/uuid=$(UUID)/" miniupnpd.conf.before > miniupnpd.conf
	$(RM) miniupnpd.conf.before

depend:	config.h
	mkdep $(ALLOBJS:.o=.c) testupnpdescgen.c testgetifstats.c \
    testupnppermissions.c miniupnpdctl.c testgetifaddr.c

miniupnpd: config.h $(ALLOBJS)
	$(CC) $(CFLAGS) -o $@ $(ALLOBJS) $(LIBS)

# BSDmake :
#	$(CC) $(CFLAGS) -o $@ $> $(LIBS)

miniupnpdctl:	config.h $(MINIUPNPDCTLOBJS)
	$(CC) $(CFLAGS) -o $@ $(MINIUPNPDCTLOBJS)

testupnpdescgen:	config.h $(TESTUPNPDESCGENOBJS)
	$(CC) $(CFLAGS) -o $@ $(TESTUPNPDESCGENOBJS)

testgetifstats:	config.h $(TESTGETIFSTATSOBJS)
	$(CC) $(CFLAGS) -o $@ $(TESTGETIFSTATSOBJS) $(LIBS)

testgetifaddr:	config.h $(TESTGETIFADDROBJS)
	$(CC) $(CFLAGS) -o $@ $(TESTGETIFADDROBJS)

testupnppermissions:	config.h $(TESTUPNPPERMISSIONSOBJS)
	$(CC) $(CFLAGS) -o $@ $(TESTUPNPPERMISSIONSOBJS)

# gmake :
#	$(CC) $(CFLAGS) -o $@ $^
# BSDmake :
#	$(CC) $(CFLAGS) -o $@ $>

config.h:	genconfig.sh VERSION
	./genconfig.sh $(CONFIG_OPTIONS)

.SUFFIXES:	.o .c
.c.o:
	$(CC) $(CFLAGS) -c -o $@ $<

#	$(CC) $(CFLAGS) -c -o $(.TARGET) $(.IMPSRC)

=== debian/changelog ===
miniupnpd (1.7-3) experimental; urgency=low

  * Added debconf support for maintaining /etc/default/miniupnpd.

 -- Thomas Goirand <zigo@debian.org>  Sun, 19 Aug 2012 09:17:20 +0000

miniupnpd (1.7-2) experimental; urgency=low

  * Only calls sed for putting a uuid if there's no value for the uuid
  in the configuration file.
  * Removes hardening option from debian/rules.
  * Fixed postinst so that it copies miniupnpd.conf from the correct location.
  Thanks to Andreas Beckmann for reporting (Closes: #685191).

 -- Thomas Goirand <zigo@debian.org>  Tue, 07 Aug 2012 07:12:45 +0000

miniupnpd (1.7-1) experimental; urgency=low

  * Initial release (Closes: #658434).

 -- Thomas Goirand <zigo@debian.org>  Tue, 10 Jul 2012 20:16:37 +0000

=== debian/control ===
Source: miniupnpd
Section: net
Priority: optional
Maintainer: Thomas Goirand <zigo@debian.org>
Build-Depends: debhelper (>= 9), iptables-dev, po-debconf
Standards-Version: 3.9.3
Homepage: http://miniupnp.free.fr/
Vcs-Browser: http://git.debian.org/?p=users/zigo/miniupnpd.git
Vcs-Git: http://git.debian.org/git/users/zigo/miniupnpd.git

Package: miniupnpd
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, debconf, iptables, iproute, uuid-runtime,
Description: daemon providing UPnP Internet Gateway Device (IGD) services
 MiniUPnPd is a small daemon providing UPnP Internet Gateway Device (IGD)
 services to your network. UPnP and NAT-PMP are used to improve internet
 connectivity for devices behind a NAT router. Any peer to peer network
 application such as games, IM, etc. can benefit from a NAT router supporting
 UPnP and/or NAT-PMP. For example the latest generation Microsoft XBOX 360 and
 Sony Playstation 3 game machines use UPnP commands to enable the online play
 with the XBOX Live service and the Playstation Network. It has been reported
 that MiniUPnPd is correctly working with the two consoles.

=== debian/rules ===
#!/usr/bin/make -f

#export DEB_BUILD_MAINT_OPTIONS = hardening=-all

%:
	dh $@

override_dh_auto_build:
	$(MAKE) -f Makefile.linux

override_dh_auto_clean:
	dh_auto_clean

	$(MAKE) -f Makefile.linux clean

override_dh_builddeb:
	dh_builddeb -- -Zxz -z9

## miniupnpd 1.8.20130730

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.68 2012/05/23 08:46:14 nanard Exp $
+# $Id: Makefile,v 1.73 2013/02/06 13:11:45 nanard Exp $
 # MiniUPnP project
 # http://miniupnp.free.fr/ or http://miniupnp.tuxfamily.org/
 # Author: Thomas Bernard
@@ -42,6 +42,7 @@
 .endif
 
 # better way to find if we are using ipf or pf
+.if defined(/etc/rc.subr) && defined(/etc/rc.conf)
 .if $(OSNAME) == "FreeBSD"
 FWNAME != . /etc/rc.subr; . /etc/rc.conf; \
           if checkyesno ipfilter_enable; then \
@@ -58,6 +59,7 @@
 FWNAME != . /etc/rc.subr; . /etc/rc.conf; \
           if chechyesno ipfilter; then \
           echo "ipf"; else echo "pf"; fi
+.endif
 .endif
 
 .if $(OSNAME) == "Darwin"
@@ -79,24 +81,27 @@
           options.o upnppermissions.o minissdp.o natpmp.o \
           upnpevents.o upnputils.o getconnstatus.o \
           upnppinhole.o
-BSDOBJS = bsd/getifstats.o bsd/ifacewatcher.o
-SUNOSOBJS = solaris/getifstats.o bsd/ifacewatcher.o
-MACOBJS = mac/getifstats.o bsd/ifacewatcher.o
+BSDOBJS = bsd/getifstats.o bsd/ifacewatcher.o bsd/getroute.o
+SUNOSOBJS = solaris/getifstats.o bsd/ifacewatcher.o bsd/getroute.o
+MACOBJS = mac/getifstats.o bsd/ifacewatcher.o bsd/getroute.o
 PFOBJS = pf/obsdrdr.o pf/pfpinhole.o
 IPFOBJS = ipf/ipfrdr.o
-IPFWOBJS = ipfw/ipfwrdr.o
+IPFWOBJS = ipfw/ipfwrdr.o ipfw/ipfwaux.o
 MISCOBJS = upnpreplyparse.o minixml.o
 
 ALLOBJS = $(STDOBJS) $(MISCOBJS)
 .if $(OSNAME) == "SunOS"
 ALLOBJS += $(SUNOSOBJS)
 TESTGETIFSTATSOBJS = testgetifstats.o solaris/getifstats.o
+TESTGETROUTEOBJS = testgetroute.o upnputils.o bsd/getroute.o
 .elif $(OSNAME) == "Darwin"
 ALLOBJS += $(MACOBJS)
 TESTGETIFSTATSOBJS = testgetifstats.o mac/getifstats.o
+TESTGETROUTEOBJS = testgetroute.o upnputils.o bsd/getroute.o
 .else
 ALLOBJS += $(BSDOBJS)
 TESTGETIFSTATSOBJS = testgetifstats.o bsd/getifstats.o
+TESTGETROUTEOBJS = testgetroute.o upnputils.o bsd/getroute.o
 .endif
 
 .if $(FWNAME) == "pf"
@@ -114,7 +119,7 @@
 
 EXECUTABLES = miniupnpd testupnpdescgen testgetifstats \
               testupnppermissions miniupnpdctl \
-              testgetifaddr
+              testgetifaddr testgetroute
 .if $(OSNAME) == "Darwin"
 LIBS =
 .else
@@ -137,7 +142,7 @@
 	$(RM) $(STDOBJS) $(BSDOBJS) $(SUNOSOBJS) $(MACOBJS) $(EXECUTABLES) \
 	testupnpdescgen.o \
 	$(MISCOBJS) config.h testgetifstats.o testupnppermissions.o \
-	miniupnpdctl.o testgetifaddr.o \
+	miniupnpdctl.o testgetifaddr.o testgetroute.o \
 	$(PFOBJS) $(IPFOBJS) $(IPFWOBJS)
 
 install:	miniupnpd genuuid
@@ -148,7 +153,7 @@
 	$(INSTALL) -b miniupnpd.conf $(DESTDIR)$(INSTALLETCDIR)
 	# TODO : install man page correctly
 #	$(INSTALL) -d $(INSTALLMANDIR)
-#	$(INSTALL) miniupnpd.1 $(INSTALLMANDIR)/cat1/miniupnpd.0
+#	$(INSTALL) miniupnpd.8 $(INSTALLMANDIR)/cat8/miniupnpd.0
 
 # genuuid is using the uuid cli tool available under OpenBSD 4.0 in
 # the uuid-1.5.0 package
@@ -167,7 +172,8 @@
 
 depend:	config.h
 	mkdep $(ALLOBJS:.o=.c) testupnpdescgen.c testgetifstats.c \
-    testupnppermissions.c miniupnpdctl.c testgetifaddr.c
+    testupnppermissions.c miniupnpdctl.c testgetifaddr.c \
+	testgetroute.c
 
 miniupnpd: config.h $(ALLOBJS)
 	$(CC) $(CFLAGS) -o $@ $(ALLOBJS) $(LIBS)
@@ -189,6 +195,9 @@
 
 testupnppermissions:	config.h $(TESTUPNPPERMISSIONSOBJS)
 	$(CC) $(CFLAGS) -o $@ $(TESTUPNPPERMISSIONSOBJS)
+
+testgetroute:	config.h $(TESTGETROUTEOBJS)
+	$(CC) $(CFLAGS) -o $@ $(TESTGETROUTEOBJS)
 
 # gmake :
 #	$(CC) $(CFLAGS) -o $@ $^

=== netfilter/Makefile ===
# $Id: Makefile,v 1.6 2012/04/26 13:50:48 nanard Exp $
CFLAGS?=-Wall -g -D_GNU_SOURCE -DDEBUG -Wstrict-prototypes -Wdeclaration-after-statement -ansi
CC = gcc

#LIBS = -liptc
LIBS = -lip4tc

ARCH := $(shell uname -m | grep -q "x86_64" && echo 64)
ifdef IPTABLESPATH
CFLAGS := $(CFLAGS) -I$(IPTABLESPATH)/include/
LDFLAGS := $(LDFLAFGS) -L$(IPTABLESPATH)/libiptc/
# get iptables version and set IPTABLES_143 macro if needed
IPTABLESVERSION := $(shell grep "\#define VERSION" $(IPTABLESPATH)/config.h | tr -d \" |cut -d" " -f3 )
IPTABLESVERSION1 := $(shell echo $(IPTABLESVERSION) | cut -d. -f1 )
IPTABLESVERSION2 := $(shell echo $(IPTABLESVERSION) | cut -d. -f2 )
IPTABLESVERSION3 := $(shell echo $(IPTABLESVERSION) | cut -d. -f3 )
# test if iptables version >= 1.4.3
TEST := $(shell [ \( \( $(IPTABLESVERSION1) -ge 1 \) -a \( $(IPTABLESVERSION2) -ge 4 \) \) -a \( $(IPTABLESVERSION3) -ge 3 \) ] && echo 1 )
ifeq ($(TEST), 1)
CFLAGS := $(CFLAGS) -DIPTABLES_143
# the following sucks, but works
LIBS = $(IPTABLESPATH)/libiptc/.libs/libip4tc.o
#LIBS = $(IPTABLESPATH)/libiptc/.libs/libiptc.a
else
LIBS = $(IPTABLESPATH)/libiptc/libiptc.a
endif
else
# check for system-wide iptables files. Test if iptables version >= 1.4.3
#TEST := $(shell test -f /usr/include/iptables/internal.h && grep -q "\#define IPTABLES_VERSION" /usr/include/iptables/internal.h && echo 1)
TEST := $(shell test -f /usr/include/xtables.h && grep -q "XTABLES_VERSION_CODE" /usr/include/xtables.h && echo 1)
ifeq ($(TEST), 1)
CFLAGS := $(CFLAGS) -DIPTABLES_143
LIBS = -liptc
TEST_LIB := $(shell test -f /usr/lib$(ARCH)/libiptc.a && echo 1)
ifeq ($(TEST_LIB), 1)
LIBS = -liptc /usr/lib$(ARCH)/libiptc.a
endif
endif
endif

all:	iptcrdr.o testiptcrdr iptpinhole.o testiptpinhole

clean:
	$(RM) *.o testiptcrdr testiptpinhole

testiptcrdr:	testiptcrdr.o iptcrdr.o upnpglobalvars.o $(LIBS)

testiptpinhole:	testiptpinhole.o iptpinhole.o upnpglobalvars.o $(LIBS)

iptcrdr.o:	iptcrdr.c iptcrdr.h

iptpinhole.o:	iptpinhole.c iptpinhole.h

upnpglobalvars.o:	../upnpglobalvars.c ../upnpglobalvars.h
	$(CC) -c -o $@ $<

=== debian/changelog ===
miniupnpd (1.8.20130730-2) unstable; urgency=low

  * Added the review from the intl team (Closes: #719950).
  * Added Debconf translations, with thanks to:
    - Japanese, victory (Closes: #724310).
    - Portuguese, Traduz (Closes: #724029).
    - French, Baptiste Jammet (Closes: #723768).
    - German, Chris Leick (Closes: #723147).
    - Czech, Michal Šimůnek (Closes: #723025).
    - Russian, Yuri Kozlov (Closes: #722602).
    - Danish, Joe Dalton (Closes: #722278).

 -- Thomas Goirand <zigo@debian.org>  Wed, 25 Sep 2013 23:30:11 +0800

miniupnpd (1.8.20130730-1) unstable; urgency=low

  * Uploading to unstable.
  * New upstream release fixing CVE-2013-2600: MiniUPnPd versions 1.8 and
    earlier are prone to an information disclosure vulnerability due to
    improper use of snprintf() while preparing SSDP responses. An attacker can
    exploit this vulnerability by sending a crafted request with a long ST
    header. If the header is long enough, the SSDP response buffer will be
    truncated by snprintf() and the subsequent sendto() call will read off the
    end of the buffer thereby disclosing the contents of adjacent memory. This
    response can reveal details of internal network topology as well as other
    activity on the target network. Fix at:
    .
    https://github.com/miniupnp/miniupnp/commit/18887cb1e49295e69c308d8bb1f2526798a77429
    .
    Correctly handle truncated snprintf() in SSDP code (Closes: #716936,
    #686537).
  * Now packaging using pristine-tar git-import-orig.
  * Added new IPv6 rules in the init script, and its configuration through
    debconf (Closes: #686287).
  * Fixed the clean process.
  * Removes now obsolete patches.
  * Build-Depends on libnfnetlink-dev.
  * Standards-Version: 3.9.4.
  * Canonical URLs for VCS feilds.

 -- Thomas Goirand <zigo@debian.org>  Tue, 23 Jul 2013 11:16:15 +0800

miniupnpd (1.7-4) experimental; urgency=low

  * Rewrite the debconf text for the external interface, which was completely
  wrong: it was asking for the LAN interface, when in fact, what was required
  was the name of the WAN interface. Also makes other Debconf questions more
  clear, writing WAN and LAN when needed (Closes: #685652).
  * Now guessed the name of the WAN interface using route (and depends on
  net-tools as a consequence).
  * Enables IPv6 and IGDv2 support build options (Closes: #685651, #685650).
  * Added display-po-stats and display-po-stats rules target.

 -- Thomas Goirand <zigo@debian.org>  Thu, 23 Aug 2012 11:45:03 +0000

=== debian/control ===
Source: miniupnpd
Section: net
Priority: optional
Maintainer: Thomas Goirand <zigo@debian.org>
Build-Depends: debhelper (>= 9), iptables-dev, po-debconf, libnfnetlink-dev
Standards-Version: 3.9.4
Homepage: http://miniupnp.free.fr/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/zigo/miniupnpd.git
Vcs-Git: http://anonscm.debian.org/git/users/zigo/miniupnpd.git

Package: miniupnpd
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, debconf, iptables, iproute, uuid-runtime, net-tools
Description: UPnP and NAT-PMP daemon for gateway routers
 MiniUPnPd is a small daemon which can be installed on a NAT router to
 provide UPnP Internet Gateway Device and Port Mapping Protocol services,
 enabling clients on the LAN to ask for port redirections. It is
 compatible with peer-to-peer software, messaging applications, and games
 consoles that connect to online services (including Xbox LIVE and the
 PlayStation Network).

=== debian/rules ===
#!/usr/bin/make -f

#export DEB_BUILD_MAINT_OPTIONS = hardening=-all

%:
	dh $@

override_dh_auto_build:
	CONFIG_OPTIONS="--ipv6 --igd2" $(MAKE) -f Makefile.linux

override_dh_auto_install:
	make -j1 -f Makefile.linux install DESTDIR=$(CURDIR)/debian/miniupnpd AM_UPDATE_INFO_DIR=no


override_dh_auto_clean:
	#dh_auto_clean

	$(MAKE) -f Makefile.linux clean

override_dh_builddeb:
	dh_builddeb -- -Zxz -z9

display-po-stats:
	cd $(CURDIR)/debian/po ; for i in *.po ; do \
		echo -n $$i": " ; \
		msgfmt -o /dev/null --statistic $$i ; \
	done

call-for-po-trans:
	podebconf-report-po --call --withtranslators --languageteam

override_dh_auto_test:
	echo "Unit tests disabled"
	#$(MAKE) -f Makefile.linux test

## miniupnpd 1.8.20140523

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.73 2013/02/06 13:11:45 nanard Exp $
+# $Id: Makefile,v 1.84 2014/04/20 16:32:17 nanard Exp $
 # MiniUPnP project
 # http://miniupnp.free.fr/ or http://miniupnp.tuxfamily.org/
 # Author: Thomas Bernard
@@ -17,7 +17,7 @@
 
 CFLAGS ?= -pipe -Os
 #CFLAGS = -pipe -O -g -DDEBUG
-CFLAGS += -ansi
+#CFLAGS += -ansi
 CFLAGS += -Wall
 CFLAGS += -W
 CFLAGS += -Wstrict-prototypes
@@ -34,19 +34,23 @@
 OSNAME != uname -s
 ARCH != uname -m
 .ifndef FWNAME
-.if exists(/usr/include/net/pfvar.h)
+#.if exists(/usr/include/net/pfvar.h)
+#FWNAME = pf
+#.else
+#FWNAME = ipf
+#.endif
+
+.if $(OSNAME) == "OpenBSD"
 FWNAME = pf
-.else
-FWNAME = ipf
-.endif
 .endif
 
 # better way to find if we are using ipf or pf
-.if defined(/etc/rc.subr) && defined(/etc/rc.conf)
+.if exists(/etc/rc.subr) && exists(/etc/rc.conf)
 .if $(OSNAME) == "FreeBSD"
 FWNAME != . /etc/rc.subr; . /etc/rc.conf; \
           if checkyesno ipfilter_enable; then \
-          echo "ipf"; else echo "pf"; fi
+          echo "ipf"; elif checkyesno pf_enable; then \
+          echo "pf"; else echo "ipfw"; fi
 .endif
 
 .if $(OSNAME) == "NetBSD"
@@ -57,13 +61,18 @@
 
 .if $(OSNAME) == "DragonFly"
 FWNAME != . /etc/rc.subr; . /etc/rc.conf; \
-          if chechyesno ipfilter; then \
-          echo "ipf"; else echo "pf"; fi
+          if checkyesno ipfilter; then \
+          echo "ipf"; elif checkyesno pf_enable; then \
+          echo "pf"; else echo "ipfw"; fi
 .endif
 .endif
 
 .if $(OSNAME) == "Darwin"
-FWNAME = ipfw
+# Firewall is ipfw up to OS X 10.6 Snow Leopard
+# and pf since OS X 10.7 Lion (Darwin 11.0)
+FWNAME != [ `uname -r | cut -d. -f1` -ge 11  ] && echo "pf" || echo "ipfw"
+.endif
+
 .endif
 
 # Solaris specific CFLAGS
@@ -78,9 +87,9 @@
 
 STDOBJS = miniupnpd.o upnphttp.o upnpdescgen.o upnpsoap.o \
           upnpredirect.o getifaddr.o daemonize.o upnpglobalvars.o \
-          options.o upnppermissions.o minissdp.o natpmp.o \
+          options.o upnppermissions.o minissdp.o natpmp.o pcpserver.o \
           upnpevents.o upnputils.o getconnstatus.o \
-          upnppinhole.o
+          upnppinhole.o asyncsendto.o portinuse.o
 BSDOBJS = bsd/getifstats.o bsd/ifacewatcher.o bsd/getroute.o
 SUNOSOBJS = solaris/getifstats.o bsd/ifacewatcher.o bsd/getroute.o
 MACOBJS = mac/getifstats.o bsd/ifacewatcher.o bsd/getroute.o
@@ -116,10 +125,14 @@
 TESTUPNPPERMISSIONSOBJS = testupnppermissions.o upnppermissions.o
 TESTGETIFADDROBJS = testgetifaddr.o getifaddr.o
 MINIUPNPDCTLOBJS = miniupnpdctl.o
+TESTASYNCSENDTOOBJS = testasyncsendto.o asyncsendto.o upnputils.o bsd/getroute.o
+TESTPORTINUSEOBJS = testportinuse.o portinuse.o getifaddr.o
 
 EXECUTABLES = miniupnpd testupnpdescgen testgetifstats \
               testupnppermissions miniupnpdctl \
-              testgetifaddr testgetroute
+              testgetifaddr testgetroute testasyncsendto \
+              testportinuse
+
 .if $(OSNAME) == "Darwin"
 LIBS =
 .else
@@ -129,6 +142,8 @@
 LIBS += -lsocket -lnsl -lkstat -lresolv
 .endif
 
+LIBS += -lssl -lcrypto
+
 # set PREFIX variable to install in the wanted place
 
 INSTALLBINDIR = $(PREFIX)/sbin
@@ -142,13 +157,14 @@
 	$(RM) $(STDOBJS) $(BSDOBJS) $(SUNOSOBJS) $(MACOBJS) $(EXECUTABLES) \
 	testupnpdescgen.o \
 	$(MISCOBJS) config.h testgetifstats.o testupnppermissions.o \
-	miniupnpdctl.o testgetifaddr.o testgetroute.o \
+	miniupnpdctl.o testgetifaddr.o testgetroute.o testasyncsendto.o \
+	testportinuse.o \
 	$(PFOBJS) $(IPFOBJS) $(IPFWOBJS)
 
 install:	miniupnpd genuuid
 	$(STRIP) miniupnpd
 	$(INSTALL) -d $(DESTDIR)$(INSTALLBINDIR)
-	$(INSTALL) -m 555 miniupnpd $(DESTDIR)$(INSTALLBINDIR)
+	$(INSTALL) -m 755 miniupnpd $(DESTDIR)$(INSTALLBINDIR)
 	$(INSTALL) -d $(DESTDIR)$(INSTALLETCDIR)
 	$(INSTALL) -b miniupnpd.conf $(DESTDIR)$(INSTALLETCDIR)
 	# TODO : install man page correctly
@@ -173,7 +189,7 @@
 depend:	config.h
 	mkdep $(ALLOBJS:.o=.c) testupnpdescgen.c testgetifstats.c \
     testupnppermissions.c miniupnpdctl.c testgetifaddr.c \
-	testgetroute.c
+	testgetroute.c testportinuse.c testasyncsendto.c
 
 miniupnpd: config.h $(ALLOBJS)
 	$(CC) $(CFLAGS) -o $@ $(ALLOBJS) $(LIBS)
@@ -185,19 +201,25 @@
 	$(CC) $(CFLAGS) -o $@ $(MINIUPNPDCTLOBJS)
 
 testupnpdescgen:	config.h $(TESTUPNPDESCGENOBJS)
-	$(CC) $(CFLAGS) -o $@ $(TESTUPNPDESCGENOBJS)
+	$(CC) $(CFLAGS) -o $@ $(TESTUPNPDESCGENOBJS) $(LIBS)
 
 testgetifstats:	config.h $(TESTGETIFSTATSOBJS)
 	$(CC) $(CFLAGS) -o $@ $(TESTGETIFSTATSOBJS) $(LIBS)
 
 testgetifaddr:	config.h $(TESTGETIFADDROBJS)
-	$(CC) $(CFLAGS) -o $@ $(TESTGETIFADDROBJS)
+	$(CC) $(CFLAGS) -o $@ $(TESTGETIFADDROBJS) $(LIBS)
 
 testupnppermissions:	config.h $(TESTUPNPPERMISSIONSOBJS)
-	$(CC) $(CFLAGS) -o $@ $(TESTUPNPPERMISSIONSOBJS)
+	$(CC) $(CFLAGS) -o $@ $(TESTUPNPPERMISSIONSOBJS) $(LIBS)
 
 testgetroute:	config.h $(TESTGETROUTEOBJS)
-	$(CC) $(CFLAGS) -o $@ $(TESTGETROUTEOBJS)
+	$(CC) $(CFLAGS) -o $@ $(TESTGETROUTEOBJS) $(LIBS)
+
+testasyncsendto:	config.h $(TESTASYNCSENDTOOBJS)
+	$(CC) $(CFLAGS) -o $@ $(TESTASYNCSENDTOOBJS)
+
+testportinuse:	config.h $(TESTPORTINUSEOBJS)
+	$(CC) $(CFLAGS) -o $@ $(TESTPORTINUSEOBJS) $(LIBS)
 
 # gmake :
 #	$(CC) $(CFLAGS) -o $@ $^

=== netfilter/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
-# $Id: Makefile,v 1.6 2012/04/26 13:50:48 nanard Exp $
-CFLAGS?=-Wall -g -D_GNU_SOURCE -DDEBUG -Wstrict-prototypes -Wdeclaration-after-statement -ansi
+# $Id: Makefile,v 1.7 2013/12/13 13:10:48 nanard Exp $
+CFLAGS?=-Wall -g -D_GNU_SOURCE -DDEBUG -Wstrict-prototypes -Wdeclaration-after-statement
 CC = gcc
 
 #LIBS = -liptc
@@ -38,14 +38,31 @@
 endif
 endif
 
-all:	iptcrdr.o testiptcrdr iptpinhole.o testiptpinhole
+LIBS +=  /lib/libip4tc.so /lib/libip6tc.so
+
+all:	iptcrdr.o testiptcrdr iptpinhole.o \
+        testiptcrdr_peer testiptcrdr_dscp test_nfct_get
+#        testiptpinhole
 
 clean:
-	$(RM) *.o testiptcrdr testiptpinhole
+	$(RM) *.o testiptcrdr testiptpinhole testiptcrdr_peer test_nfct_get \
+        testiptcrdr_dscp
 
-testiptcrdr:	testiptcrdr.o iptcrdr.o upnpglobalvars.o $(LIBS)
+testiptcrdr:	testiptcrdr.o upnpglobalvars.o $(LIBS)
+
+testiptcrdr_peer:	testiptcrdr_peer.o upnpglobalvars.o $(LIBS)
+
+testiptcrdr_dscp:	testiptcrdr_dscp.o upnpglobalvars.o $(LIBS)
 
 testiptpinhole:	testiptpinhole.o iptpinhole.o upnpglobalvars.o $(LIBS)
+
+test_nfct_get:	test_nfct_get.o test_nfct_get.o -lmnl -lnetfilter_conntrack
+
+test_nfct_get.o:	test_nfct_get.c
+
+testiptcrdr_peer.o:	testiptcrdr_peer.c
+
+testiptcrdr_dscp.o:	testiptcrdr_dscp.c
 
 iptcrdr.o:	iptcrdr.c iptcrdr.h

=== pf/Makefile ===
# $Id: Makefile,v 1.4 2012/04/18 20:45:33 nanard Exp $
# made for GNU Make (and BSD make)
CFLAGS = -Wall -g -ansi -DTEST
EXECUTABLES = testobsdrdr testpfpinhole

all:	$(EXECUTABLES)

clean:
	rm -f *.o $(EXECUTABLES)

testobsdrdr:	testobsdrdr.o obsdrdr.o
	$(CC) $(CFLAGS) -o $@ $>

testpfpinhole:	testpfpinhole.o obsdrdr.o pfpinhole.o
	$(CC) $(CFLAGS) -o $@ $>

obsdrdr.o:	obsdrdr.c obsdrdr.h

pfpinhole.o:	pfpinhole.c pfpinhole.h

testobsdrdr.o:	testobsdrdr.c obsdrdr.h

testpfpinhole.o:	testpfpinhole.c pfpinhole.h

=== debian/changelog ===
miniupnpd (1.8.20140523-4) unstable; urgency=high

  * Fixes multiple vulnerabilities (Closes: #772644).

 -- Thomas Goirand <zigo@debian.org>  Tue, 09 Dec 2014 22:29:04 +0800

miniupnpd (1.8.20140523-3) unstable; urgency=medium

  * Do not install the configuration file in /etc/miniupnpd, use /usr/share
    instead, so that miniupnpd.conf isn't CONFFILE (Closes: #767646).
  * Do not use /usr/share/doc/miniupnpd/examples to get our default config
    file, which isn't policy compliant, but use /usr/share/miniupnpd.

 -- Thomas Goirand <zigo@debian.org>  Tue, 04 Nov 2014 16:35:36 +0800

miniupnpd (1.8.20140523-2) unstable; urgency=medium

  * Removed $all from init script.

 -- Thomas Goirand <zigo@debian.org>  Mon, 14 Jul 2014 07:08:43 +0000

miniupnpd (1.8.20140523-1) unstable; urgency=medium

  * New upstream release (Closes: #749392).
  * Standards-Version: bumped to 3.9.5.

 -- Thomas Goirand <zigo@debian.org>  Sun, 08 Jun 2014 09:35:49 +0000

miniupnpd (1.8.20130730-3) unstable; urgency=medium

  * Now depending on iproute2 instead of iproute.
  * Added Italian debconf translaiton (Closes: #724684).
  * Added Spanish debconf translation, thanks to "Matias A. Bellone"
    <matiasbellone+debian@gmail.com> (Closes: #733065).
  * Added Swedish debconf translation, thanks to Martin Bagge
    <brother@bsnet.se> (Closes: #727185).
  * Fixed postinst that is destroying the default file (Closes: #726915).
  * Fixed wrong directive for enabling ipv6.

 -- Thomas Goirand <zigo@debian.org>  Wed, 28 May 2014 16:10:53 +0800

=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,12 @@
 override_dh_auto_install:
 	make -j1 -f Makefile.linux install DESTDIR=$(CURDIR)/debian/miniupnpd AM_UPDATE_INFO_DIR=no
 
+	# Move the miniupnpd.conf in /usr/share so it's not marked as CONFFILE
+	mkdir -p $(CURDIR)/debian/miniupnpd/usr/share/miniupnpd
+	mv $(CURDIR)/debian/miniupnpd/etc/miniupnpd/miniupnpd.conf $(CURDIR)/debian/miniupnpd/usr/share/miniupnpd/miniupnpd.conf
+
+	# Copy the /etc/default/miniupnpd to /usr/share
+	cp $(CURDIR)/debian/examples/miniupnpd.default $(CURDIR)/debian/miniupnpd/usr/share/miniupnpd
 
 override_dh_auto_clean:
 	#dh_auto_clean

## miniupnpd 2.0.20171212

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.84 2014/04/20 16:32:17 nanard Exp $
+# $Id: Makefile,v 1.90 2017/12/12 11:40:13 nanard Exp $
 # MiniUPnP project
 # http://miniupnp.free.fr/ or http://miniupnp.tuxfamily.org/
 # Author: Thomas Bernard
@@ -45,25 +45,37 @@
 .endif
 
 # better way to find if we are using ipf or pf
-.if exists(/etc/rc.subr) && exists(/etc/rc.conf)
 .if $(OSNAME) == "FreeBSD"
-FWNAME != . /etc/rc.subr; . /etc/rc.conf; \
+.if exists(/etc/rc.subr) && exists(/etc/default/rc.conf)
+FWNAME != . /etc/rc.subr; . /etc/default/rc.conf; \
           if checkyesno ipfilter_enable; then \
           echo "ipf"; elif checkyesno pf_enable; then \
-          echo "pf"; else echo "ipfw"; fi
+          echo "pf"; elif checkyesno firewall_enable; then \
+          echo "ipfw"; else echo "pf"; fi
+.else
+FWNAME = pf
+.endif
 .endif
 
 .if $(OSNAME) == "NetBSD"
+.if exists(/etc/rc.subr) && exists(/etc/rc.conf)
 FWNAME != . /etc/rc.subr; . /etc/rc.conf; \
-          if checkyesno ipfilter; then \
+          if checkyesno pf; then \
+          echo "pf"; elif checkyesno ipfilter; then \
           echo "ipf"; else echo "pf"; fi
+.else
+FWNAME = pf
+.endif
 .endif
 
 .if $(OSNAME) == "DragonFly"
+.if exists(/etc/rc.subr) && exists(/etc/rc.conf)
 FWNAME != . /etc/rc.subr; . /etc/rc.conf; \
-          if checkyesno ipfilter; then \
-          echo "ipf"; elif checkyesno pf_enable; then \
-          echo "pf"; else echo "ipfw"; fi
+          if checkyesno pf; then \
+          echo "pf"; elif checkyesno ipfilter; then \
+          echo "ipf"; else echo "pf"; fi
+.else
+FWNAME = pf
 .endif
 .endif
 
@@ -127,11 +139,13 @@
 MINIUPNPDCTLOBJS = miniupnpdctl.o
 TESTASYNCSENDTOOBJS = testasyncsendto.o asyncsendto.o upnputils.o bsd/getroute.o
 TESTPORTINUSEOBJS = testportinuse.o portinuse.o getifaddr.o
+TESTMINISSDPOBJS = testminissdp.o minissdp.o upnputils.o upnpglobalvars.o \
+                   asyncsendto.o bsd/getroute.o
 
 EXECUTABLES = miniupnpd testupnpdescgen testgetifstats \
               testupnppermissions miniupnpdctl \
               testgetifaddr testgetroute testasyncsendto \
-              testportinuse
+              testportinuse testssdppktgen testminissdp
 
 .if $(OSNAME) == "Darwin"
 LIBS =
@@ -160,6 +174,7 @@
 	miniupnpdctl.o testgetifaddr.o testgetroute.o testasyncsendto.o \
 	testportinuse.o \
 	$(PFOBJS) $(IPFOBJS) $(IPFWOBJS)
+	$(RM) validateupnppermissions validategetifaddr validatessdppktgen
 
 install:	miniupnpd genuuid
 	$(STRIP) miniupnpd
@@ -181,45 +196,66 @@
         else echo "00000000-0000-0000-0000-000000000000"; \
         fi
 
+# bash or ksh
+SH != which bash || which ksh
+
 genuuid:
 	$(MV) miniupnpd.conf miniupnpd.conf.before
 	sed -e "s/^uuid=[-0-9a-fA-F]*/uuid=$(UUID)/" miniupnpd.conf.before > miniupnpd.conf
 	$(RM) miniupnpd.conf.before
 
+check:  validateupnppermissions validategetifaddr validatessdppktgen
+
+validateupnppermissions: testupnppermissions testupnppermissions.sh
+	$(SH) ./testupnppermissions.sh
+	touch $@
+
+validategetifaddr:	testgetifaddr testgetifaddr.sh
+	./testgetifaddr.sh
+	touch $@
+
+validatessdppktgen:	testssdppktgen
+	./testssdppktgen
+	touch $@
+
 depend:	config.h
 	mkdep $(ALLOBJS:.o=.c) testupnpdescgen.c testgetifstats.c \
     testupnppermissions.c miniupnpdctl.c testgetifaddr.c \
-	testgetroute.c testportinuse.c testasyncsendto.c
+	testgetroute.c testportinuse.c testasyncsendto.c \
+	testssdppktgen.c
 
 miniupnpd: config.h $(ALLOBJS)
-	$(CC) $(CFLAGS) -o $@ $(ALLOBJS) $(LIBS)
+	$(CC) $(LDFLAGS) -o $@ $(ALLOBJS) $(LIBS)
 
 # BSDmake :
-#	$(CC) $(CFLAGS) -o $@ $> $(LIBS)
+#	$(CC) $(LDFLAGS) -o $@ $> $(LIBS)
 
 miniupnpdctl:	config.h $(MINIUPNPDCTLOBJS)
-	$(CC) $(CFLAGS) -o $@ $(MINIUPNPDCTLOBJS)
+	$(CC) $(LDFLAGS) -o $@ $(MINIUPNPDCTLOBJS)
 
 testupnpdescgen:	config.h $(TESTUPNPDESCGENOBJS)
-	$(CC) $(CFLAGS) -o $@ $(TESTUPNPDESCGENOBJS) $(LIBS)
+	$(CC) $(LDFLAGS) -o $@ $(TESTUPNPDESCGENOBJS) $(LIBS)
 
 testgetifstats:	config.h $(TESTGETIFSTATSOBJS)
-	$(CC) $(CFLAGS) -o $@ $(TESTGETIFSTATSOBJS) $(LIBS)
+	$(CC) $(LDFLAGS) -o $@ $(TESTGETIFSTATSOBJS) $(LIBS)
 
 testgetifaddr:	config.h $(TESTGETIFADDROBJS)
-	$(CC) $(CFLAGS) -o $@ $(TESTGETIFADDROBJS) $(LIBS)
+	$(CC) $(LDFLAGS) -o $@ $(TESTGETIFADDROBJS) $(LIBS)
 
 testupnppermissions:	config.h $(TESTUPNPPERMISSIONSOBJS)
-	$(CC) $(CFLAGS) -o $@ $(TESTUPNPPERMISSIONSOBJS) $(LIBS)
+	$(CC) $(LDFLAGS) -o $@ $(TESTUPNPPERMISSIONSOBJS) $(LIBS)
 
 testgetroute:	config.h $(TESTGETROUTEOBJS)
-	$(CC) $(CFLAGS) -o $@ $(TESTGETROUTEOBJS) $(LIBS)
+	$(CC) $(LDFLAGS) -o $@ $(TESTGETROUTEOBJS) $(LIBS)
 
 testasyncsendto:	config.h $(TESTASYNCSENDTOOBJS)
-	$(CC) $(CFLAGS) -o $@ $(TESTASYNCSENDTOOBJS)
+	$(CC) $(LDFLAGS) -o $@ $(TESTASYNCSENDTOOBJS)
 
 testportinuse:	config.h $(TESTPORTINUSEOBJS)
-	$(CC) $(CFLAGS) -o $@ $(TESTPORTINUSEOBJS) $(LIBS)
+	$(CC) $(LDFLAGS) -o $@ $(TESTPORTINUSEOBJS) $(LIBS)
+
+testminissdp:	config.h $(TESTMINISSDPOBJS)
+	$(CC) $(LDFLAGS) -o $@ $(TESTMINISSDPOBJS) $(LIBS)
 
 # gmake :
 #	$(CC) $(CFLAGS) -o $@ $^

=== netfilter_nft/Makefile ===
CFLAGS?=-Wall -g -D_GNU_SOURCE -DDEBUG -Wstrict-prototypes -Wdeclaration-after-statement
CC = gcc

LIBS = -lnftnl -lmnl

ARCH := $(shell uname -m | grep -q "x86_64" && echo 64)

all:	test_nfct_get testnftnlrdr 

clean:
	$(RM) *.o testnftnlcrdr testnftnlpinhole testnftnlrdr_peer \
		test_nfct_get testnftnlrdr 

testnftnlrdr:	nftnlrdr.o nftnlrdr_misc.o testnftnlrdr.o upnpglobalvars.o $(LIBS)

testiptpinhole:	testiptpinhole.o iptpinhole.o upnpglobalvars.o $(LIBS)

test_nfct_get:	test_nfct_get.o test_nfct_get.o -lmnl -lnetfilter_conntrack

test_nfct_get.o:	test_nfct_get.c

testnftnlrdr_peer.o:	testnftnlrdr_peer.c

testnftnlrdr_dscp.o:	testnftnlrdr_dscp.c

nftnlrdr.o:		nftnlrdr.c nftnlrdr.h 

nftnlrdr_misc.o:	nftnlrdr_misc.c

iptpinhole.o:		iptpinhole.c iptpinhole.h

upnpglobalvars.o:	../upnpglobalvars.c ../upnpglobalvars.h
	$(CC) -c -o $@ $<

=== debian/changelog ===
miniupnpd (2.0.20171212-2) unstable; urgency=medium

  * Removed --igd2 option when building, as per recommendation from upstream.
    The igd2 protocol is basically a failure, and we should not use it, as it
    breaks igd1 clients.

 -- Thomas Goirand <zigo@debian.org>  Mon, 12 Feb 2018 10:02:25 +0000

miniupnpd (2.0.20171212-1) unstable; urgency=medium

  [ Yangfl ]
  * New upstream release (Closes: #850411).
    - Fix V6SOCKETS_ARE_V6ONLY on Linux (Closes: #771918)
    - Default reverted to UDA 1.1 (Closes: #885960)
    - Fix CVE-2017-1000494 (Closes: #887129)
  * Enable manufacturer info configuration (Closes: #877564).
  * Allow IPv4 listening specify (Closes: #885825).
  * Bumped Standards-Version.

  [ Thomas Goirand ]
  * Fixed VCS URLs to point to Salsa.
  * Ran wrap-and-sort -bast.
  * Fixed debian/gbp.conf.

 -- Thomas Goirand <zigo@debian.org>  Thu, 01 Feb 2018 16:39:16 +0000

=== debian/control ===
Source: miniupnpd
Section: net
Priority: optional
Maintainer: Thomas Goirand <zigo@debian.org>
Uploaders:
 Yangfl <mmyangfl@gmail.com>,
Build-Depends:
 debhelper (>= 11),
 iptables-dev,
 libnfnetlink-dev,
 po-debconf,
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/miniupnp-team/miniupnpd
Vcs-Git: https://salsa.debian.org/miniupnp-team/miniupnpd.git
Homepage: http://miniupnp.free.fr/

Package: miniupnpd
Architecture: any
Depends:
 debconf,
 iproute2 | iproute,
 iptables,
 lsb-base,
 net-tools,
 uuid-runtime,
 ${misc:Depends},
 ${shlibs:Depends},
Description: UPnP and NAT-PMP daemon for gateway routers
 MiniUPnPd is a small daemon which can be installed on a NAT router to
 provide UPnP Internet Gateway Device and Port Mapping Protocol services,
 enabling clients on the LAN to ask for port redirections. It is
 compatible with peer-to-peer software, messaging applications, and games
 consoles that connect to online services (including Xbox LIVE and the
 PlayStation Network).

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

override_dh_auto_clean:
	$(MAKE) -f Makefile.linux clean

override_dh_clean:
	if [ -h Makefile ]; then \
		mv Makefile.bsd Makefile; \
	fi
	dh_clean

override_dh_auto_configure:
	if [ ! -h Makefile ]; then \
		mv Makefile Makefile.bsd; \
		ln -s Makefile.linux Makefile; \
	fi
	dh_auto_configure

override_dh_auto_build:
	dh_auto_build -- CONFIG_OPTIONS="--ipv6 --leasefile --vendorcfg --pcp-peer --portinuse"

override_dh_auto_test:

override_dh_auto_install:
	dh_auto_install -- STRIP=echo

	# Move the miniupnpd.conf in /usr/share so it's not marked as CONFFILE
	mkdir -p $(CURDIR)/debian/miniupnpd/usr/share/miniupnpd
	mv $(CURDIR)/debian/miniupnpd/etc/miniupnpd/miniupnpd.conf $(CURDIR)/debian/miniupnpd/usr/share/miniupnpd/miniupnpd.conf
	sed -i -e "s/^uuid=[-0-9a-f]*/uuid=/" $(CURDIR)/debian/miniupnpd/usr/share/miniupnpd/miniupnpd.conf

display-po-stats:
	cd $(CURDIR)/debian/po ; for i in *.po ; do \
		echo -n $$i": " ; \
		msgfmt -o /dev/null --statistic $$i ; \
	done

call-for-po-trans:
	podebconf-report-po --call --withtranslators --languageteam

=== debian/watch ===
version=4
opts=filenamemangle=s/.*file=([^&]*)/$1/ \
	http://miniupnp.free.fr/files/download.php\?file=miniupnpd-(\d\.\d.*).tar.gz

## miniupnpd 2.1

=== debian/changelog ===
miniupnpd (2.1-6) unstable; urgency=medium

  * Add upstream patches for CVE-2019-12107 CVE-2019-12108 CVE-2019-12109
    CVE-2019-12110 CVE-2019-12111 (Closes: #930050).

 -- Thomas Goirand <zigo@debian.org>  Fri, 07 Jun 2019 00:37:36 +0200

miniupnpd (2.1-5) unstable; urgency=medium

  * Update Danish Debconf translation, thanks to Joe Dalton (Closes: #923134).

 -- Yangfl <mmyangfl@gmail.com>  Wed, 27 Feb 2019 14:55:02 +0800

miniupnpd (2.1-4) unstable; urgency=medium

  * Fix autopkgtest.
  * Update Debconf translations, with thanks to:
    - Portuguese, Américo Monteiro (Closes: #919211).
    - German, Chris Leick (Closes: #919784).
    - Dutch, Frans Spiesschaert (Closes: #920431).
    - Vietnamese, Trần Ngọc Quân.

 -- Yangfl <mmyangfl@gmail.com>  Tue, 08 Jan 2019 15:16:49 +0800

miniupnpd (2.1-3) unstable; urgency=medium

  * Remove START_DAEMON in /etc/default/miniupnpd.
  * Update Debconf translations, with thanks to:
    - Dutch, Frans Spiesschaert (Closes: #906940).
    - German, Chris Leick (Closes: #907588).
    - French, Baptiste Jammet (Closes: #908901).
    - Portuguese, Américo Monteiro (Closes: #910456).
  * Add autopkgtest.
  * Bump Standards-Version to 4.3.0.
  * Bump debhelper compat to 12.

 -- Yangfl <mmyangfl@gmail.com>  Sun, 06 Jan 2019 21:42:58 +0800

miniupnpd (2.1-2) unstable; urgency=medium

  * Disable kfreebsd-any due to lack of iptables.
  * Remove obsolete default file in favor of debconf.
  * Add debconf option for `force_igd_desc_v1'.
  * Fix sed command bug in postinst (Closes: #901632).
  * debian/miniupnpd.config: Always prefer configs in debconf to prevent config
    loss during fresh installation.
  * debian/rules: Disable auto enabling systemd service.
  * Bump Standards-Version to 4.2.0.

 -- Yangfl <mmyangfl@gmail.com>  Wed, 15 Aug 2018 16:23:40 +0800

miniupnpd (2.1-1) unstable; urgency=medium

  * New upstream release.
  * Disable hurd-any due to lack of rt_msghdr and RTM_*.
  * Add --igd2 back, since 'force_igd_desc_v1' is now available.
  * Deprecate MiniUPnPd_EXTERNAL_INTERFACE and MiniUPnPd_LISTENING_IP in
    /etc/default/miniupnpd (Closes: #891088).
  * Add systemd service file.
  * Add Debconf translations, with thanks to:
    - Brazilian Portuguese, Adriano Rafael Gomes (Closes: #891168).
    - Dutch, Frans Spiesschaert (Closes: #899025).
  * Update patch file.
  * Bump Standards-Version to 4.1.4.
  * debian/watch: Check for PGP signature.
  * debian/watch: Only watch for release versions.

 -- Yangfl <mmyangfl@gmail.com>  Tue, 12 Jun 2018 11:39:08 +0800

=== debian/control ===
--- 
+++ 
@@ -5,20 +5,22 @@
 Uploaders:
  Yangfl <mmyangfl@gmail.com>,
 Build-Depends:
- debhelper (>= 11),
+ debhelper (>= 12~),
  iptables-dev,
- libnfnetlink-dev,
+ pkg-config,
  po-debconf,
-Standards-Version: 4.1.3
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/miniupnp-team/miniupnpd
 Vcs-Git: https://salsa.debian.org/miniupnp-team/miniupnpd.git
 Homepage: http://miniupnp.free.fr/
 
 Package: miniupnpd
-Architecture: any
+Architecture: linux-any
+Pre-Depends:
+ ${misc:Pre-Depends},
 Depends:
  debconf,
- iproute2 | iproute,
+ iproute2,
  iptables,
  lsb-base,
  net-tools,

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,6 @@
 #!/usr/bin/make -f
 #export DH_VERBOSE = 1
+
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
@@ -12,6 +13,7 @@
 
 override_dh_auto_clean:
 	$(MAKE) -f Makefile.linux clean
+	rm -rf config.h
 
 override_dh_clean:
 	if [ -h Makefile ]; then \
@@ -27,17 +29,34 @@
 	dh_auto_configure
 
 override_dh_auto_build:
-	dh_auto_build -- CONFIG_OPTIONS="--ipv6 --leasefile --vendorcfg --pcp-peer --portinuse"
+	dh_auto_build -- CONFIG_OPTIONS="--igd2 --ipv6 --leasefile --vendorcfg --pcp-peer --portinuse"
 
 override_dh_auto_test:
+	# some test scripts missing from the tarball
 
 override_dh_auto_install:
 	dh_auto_install -- STRIP=echo
 
 	# Move the miniupnpd.conf in /usr/share so it's not marked as CONFFILE
 	mkdir -p $(CURDIR)/debian/miniupnpd/usr/share/miniupnpd
-	mv $(CURDIR)/debian/miniupnpd/etc/miniupnpd/miniupnpd.conf $(CURDIR)/debian/miniupnpd/usr/share/miniupnpd/miniupnpd.conf
-	sed -i -e "s/^uuid=[-0-9a-f]*/uuid=/" $(CURDIR)/debian/miniupnpd/usr/share/miniupnpd/miniupnpd.conf
+	mv $(CURDIR)/debian/miniupnpd/etc/miniupnpd/miniupnpd.conf $(CURDIR)/debian/miniupnpd/usr/share/miniupnpd/
+	sed -i " \
+		/^secure_mode=no/ d; \
+		/^notify_interval=60/ d; \
+		s/^clean_ruleset_interval=600/#clean_ruleset_interval=600/; \
+		s/^allow/#allow/; \
+		s/^deny/#deny/; \
+		s/^uuid=.*/uuid=/; \
+	" $(CURDIR)/debian/miniupnpd/usr/share/miniupnpd/miniupnpd.conf
+
+	# Copy the /etc/default/miniupnpd to /usr/share
+	cp $(CURDIR)/debian/examples/miniupnpd.default $(CURDIR)/debian/miniupnpd/usr/share/miniupnpd/
+
+override_dh_installinit:
+	dh_installinit --no-enable --no-start
+
+override_dh_installsystemd:
+	dh_installsystemd --no-enable --no-start
 
 display-po-stats:
 	cd $(CURDIR)/debian/po ; for i in *.po ; do \

## miniupnpd 2.2.1

=== debian/changelog ===
miniupnpd (2.2.1-1) unstable; urgency=medium

  * New upstream release
  * Upload to unstable

 -- Yangfl <mmyangfl@gmail.com>  Mon, 04 Jan 2021 21:48:54 +0800

miniupnpd (2.2.0-1) experimental; urgency=medium

  * New upstream release (Closes: #973511).
    - Fix iptables-init.sh for POSTROUTING (Closes: #955779).
  * Remove dep of net-tools (Closes: #961701).
  * Provide iptables and nftables-backended binaries (Closes: #961723).
  * Disable leasefile (Closes: #961877).
  * Harden systemd service (Closes: #962088).
  * Bump debhelper compat to 13.
  * Bump Standards-Version to 4.5.0.
  * Add upstream metadata.

 -- Yangfl <mmyangfl@gmail.com>  Tue, 17 Nov 2020 22:17:01 +0800

miniupnpd (2.1-6.1) unstable; urgency=medium

  * Non-maintainer upload.
  [ Thomas Goirand ]
  * Added a debian/salsa-ci.yml

  [ Laurent Bigonville ]
  * Cherry-pick patches from upstream to fix FTBFS with linux > 5.0
    (Closes: #931978)
  * Update the French debconf translation (Closes: #935152)
  * Update the Italian debconf translation (Closes: #952802)
  * Remove iptables-dev from the BD, add libiptc-dev and libxtables-dev
    instead (Closes: #946150)
  * debian/miniupnpd.service: Pass -d to miniupnpd and set Type to simple.
    That way systemd will detect whether the process is exiting with a
    non-zero code or not and properly track the it.

 -- Laurent Bigonville <bigon@debian.org>  Fri, 27 Mar 2020 14:11:07 +0100

=== debian/control ===
Source: miniupnpd
Section: net
Priority: optional
Maintainer: Thomas Goirand <zigo@debian.org>
Uploaders:
 Yangfl <mmyangfl@gmail.com>,
Build-Depends:
 debhelper-compat (= 13),
 libiptc-dev,
 libxtables-dev,
 libnftnl-dev,
 libmnl-dev,
 pkg-config,
 po-debconf,
Rules-Requires-Root: no
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/miniupnp-team/miniupnpd
Vcs-Git: https://salsa.debian.org/miniupnp-team/miniupnpd.git
Homepage: http://miniupnp.free.fr/

Package: miniupnpd
Architecture: all
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 debconf,
 lsb-base,
 uuid-runtime,
 miniupnpd-nftables | miniupnpd-iptables,
 ${misc:Depends},
Description: UPnP and NAT-PMP daemon for gateway routers
 MiniUPnPd is a small daemon which can be installed on a NAT router to
 provide UPnP Internet Gateway Device and Port Mapping Protocol services,
 enabling clients on the LAN to ask for port redirections. It is
 compatible with peer-to-peer software, messaging applications, and games
 consoles that connect to online services (including Xbox LIVE and the
 PlayStation Network).

Package: miniupnpd-nftables
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts: miniupnpd-iptables
Breaks: miniupnpd (<< 2.2.0)
Replaces: miniupnpd (<< 2.2.0)
Description: UPnP and NAT-PMP daemon for gateway routers - nftables backend
 MiniUPnPd is a small daemon which can be installed on a NAT router to
 provide UPnP Internet Gateway Device and Port Mapping Protocol services,
 enabling clients on the LAN to ask for port redirections. It is
 compatible with peer-to-peer software, messaging applications, and games
 consoles that connect to online services (including Xbox LIVE and the
 PlayStation Network).
 .
 This package provides miniupnpd with nftables backend.

Package: miniupnpd-iptables
Architecture: linux-any
Depends:
 iptables,
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts: miniupnpd-nftables
Breaks: miniupnpd (<< 2.2.0)
Replaces: miniupnpd (<< 2.2.0)
Description: UPnP and NAT-PMP daemon for gateway routers - legacy iptables backend
 MiniUPnPd is a small daemon which can be installed on a NAT router to
 provide UPnP Internet Gateway Device and Port Mapping Protocol services,
 enabling clients on the LAN to ask for port redirections. It is
 compatible with peer-to-peer software, messaging applications, and games
 consoles that connect to online services (including Xbox LIVE and the
 PlayStation Network).
 .
 This package provides miniupnpd with iptables backend. The iptables/xtables
 framework has been replaced by nftables. You should consider migrating now.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND =

export SRCDIR = .


%:
	dh $@

override_dh_auto_clean:
	+$(MAKE) -f Makefile.linux clean
	rm -f .configure.cache config.mk config.h Makefile netfilter/miniupnpd netfilter_nft/miniupnpd

override_dh_auto_configure:
	# skip

override_dh_auto_build:
	./configure --igd2 --ipv6 --vendorcfg --pcp-peer --portinuse --firewall=iptables
	+$(MAKE) -f Makefile.linux miniupnpd
	mv miniupnpd netfilter/
	+$(MAKE) -f Makefile.linux clean
	./configure --igd2 --ipv6 --vendorcfg --pcp-peer --portinuse --firewall=nftables
	+$(MAKE) -f Makefile.linux_nft miniupnpd
	mv miniupnpd netfilter_nft/

override_dh_auto_test:
	# some test scripts missing from the tarball

override_dh_auto_install:
	+$(MAKE) -f Makefile.linux_nft install STRIP=echo DESTDIR=debian/tmp
	+$(MAKE) -f Makefile.linux install STRIP=echo DESTDIR=debian/tmp
	# I don't know why
	rm debian/tmp/etc/miniupnpd/miniupnpd.conf~

execute_after_dh_install-indep:
	# Move the miniupnpd.conf in /usr/share so it's not marked as CONFFILE
	mkdir -p $(CURDIR)/debian/miniupnpd/usr/share/miniupnpd
	mv $(CURDIR)/debian/miniupnpd/etc/miniupnpd/miniupnpd.conf $(CURDIR)/debian/miniupnpd/usr/share/miniupnpd/
	sed -i " \
		/^secure_mode=no/ d; \
		/^notify_interval=60/ d; \
		s/^clean_ruleset_interval=600/#clean_ruleset_interval=600/; \
		s/^allow/#allow/; \
		s/^deny/#deny/; \
		s/^uuid=.*/uuid=/; \
	" $(CURDIR)/debian/miniupnpd/usr/share/miniupnpd/miniupnpd.conf

	# Copy the /etc/default/miniupnpd to /usr/share
	cp $(CURDIR)/debian/examples/miniupnpd.default $(CURDIR)/debian/miniupnpd/usr/share/miniupnpd/

override_dh_installinit-indep:
	dh_installinit -i --no-enable --no-start

override_dh_installsystemd-indep:
	dh_installsystemd -i --no-enable --no-start


############################################
### Below is to manage upstream Git repo ###
### and is not used during package build ###
############################################

display-po-stats:
	cd $(CURDIR)/debian/po ; for i in *.po ; do \
		echo -n $$i": " ; \
		msgfmt -o /dev/null --statistic $$i ; \
	done

call-for-po-trans:
	podebconf-report-po --call --withtranslators --languageteam
